%global _vendor OpenCloudOS
%global rpmmdir /usr/lib/rpm/%{_vendor}
%global python_version_release 3.11-1

Summary:          OpencloudOS specific rpm configuration files
Name:             opencloudos-rpm-config
Version:          1.0
Release:          26%{?dist}
License:          GPLv3
URL:              https://gitee.com/opencloudos-stream/opencloudos-rpm-config

Source0:          macros
Source1:          rpmrc
Source2:          OpenCloudOS-hardened-cc1
Source3:          OpenCloudOS-hardened-ld
Source4:          brp-mangle-shebangs
Source5:          brp-llvm-compile-lto-elf
# https://git.savannah.gnu.org/cgit/config.git/plain/config.guess
Source6:          config.guess
# https://git.savannah.gnu.org/cgit/config.git/plain/config.sub
Source7:          config.sub
Source8:          brp-ldconfig
Source9:          brp-strip-lto
Source10:         common.lua
Source11:         macros.python
Source12:         COPYING

# Implementation files for pyproject
Source13:         pyproject_buildrequires.py
Source14:         pyproject_save_files.py
Source15:         pyproject_convert.py
Source16:         pyproject_preprocess_record.py
Source17:         pyproject_construct_toxenv.py
Source18:         pyproject_requirements_txt.py
Source19:         macros.pyproject

Source20:         brp-fix-pyc-reproducibility
Source21:         brp-python-bytecompile
Source22:         brp-python-hardlink
Source23:         python.lua
Source24:         gpgverify
Source25:         macros.go-compilers-golang
Source26:         libsymlink.attr
Source27:         macros.java-srpm
Source28:         macros.nodejs-srpm
Source29:         forge.lua
Source30:         macros.forge
Source31:         macros.go-rpm

BuildArch:        noarch
BuildRequires:    perl-generators
Requires:         coreutils, rpm >= 4.11.0, dwz >= 0.4, zip
Requires:         %{_bindir}/find, %{_bindir}/file, %{_bindir}/grep, %{_bindir}/sed, %{_bindir}/xargs
Requires:         efi-srpm-macros, fonts-srpm-macros, go-rpm-macros, rust-srpm-macros
Requires:         (llvm if clang)

Provides:         lua-srpm-macros = %{version}-%{release}
Provides:         lua-rpm-macros = %{version}-%{release}
Provides:         python-srpm-macros = %{python_version_release}
Provides:         python3-rpm-macros = %{python_version_release}
Provides:         python-rpm-macros = %{python_version_release}
Provides:         system-rpm-config = %{version}-%{release}
Provides:         pyproject-rpm-macros = %{version}-%{release}
Provides:         system-rpm-config = %{version}-%{release}
Provides:         package-notes-srpm-macros = %{version}-%{release}


%description
OpencloudOS specific rpm configuration files.

%package -n    go-rpm-macros
Summary:       Build-stage rpm automation for Go packages
Requires:      %{name} = %{version}-%{release}, golang

%description -n go-rpm-macros
This package provides build-stage rpm automation to simplify the creation of Go
language (golang) packages.

%prep
%setup -c -T
cp -p %{sources} .


%install
mkdir -p %{buildroot}%{rpmmdir}
install -p -m644 macros %{buildroot}%{rpmmdir}
install -p -m644 rpmrc %{buildroot}%{rpmmdir}
install -p -m444 %{_vendor}-hardened-* %{buildroot}%{rpmmdir}
install -p -m755 config.* %{buildroot}%{rpmmdir}
install -p -m755 brp-* %{buildroot}%{rpmmdir}
install -p -m755 gpgverify %{buildroot}%{rpmmdir}

mkdir -p %{buildroot}%{_rpmconfigdir}/macros.d
mkdir -p %{buildroot}%{_rpmconfigdir}/%{_vendor}
mkdir -p %{buildroot}%{_fileattrsdir}
mkdir -p %{buildroot}%{_rpmluadir}/%{_vendor}/{rpm,srpm}

install -p -m644 macros.* %{buildroot}%{_rpmconfigdir}/macros.d
install -p -m644 macros.go-compilers-golang %{buildroot}%{_rpmconfigdir}/macros.d
install -p -m644 macros.go-rpm %{buildroot}%{_rpmconfigdir}/macros.d
install -p -m644 pyproject* %{buildroot}%{_rpmconfigdir}/%{_vendor}/
install -p -m644 common.lua %{buildroot}%{_rpmluadir}/%{_vendor}
install -p -m644 forge.lua %{buildroot}%{_rpmluadir}/%{_vendor}/srpm
install -p -m644 python.lua %{buildroot}%{_rpmluadir}/%{_vendor}/srpm
install -p -m644 -t %{buildroot}%{_fileattrsdir} *.attr


%files
%license COPYING
%{rpmmdir}/
%{_fileattrsdir}/
%{_rpmconfigdir}/macros.d/
%dir %{_rpmluadir}/%{_vendor}
%{_rpmluadir}/%{_vendor}/*
%exclude %{_rpmconfigdir}/macros.d/macros.go-compilers-golang

%files -n go-rpm-macros
%{_rpmconfigdir}/macros.d/macros.go-compilers-golang
%{_rpmconfigdir}/macros.d/macros.go-rpm


%changelog
* Tue Jul 16 2024 cunshunxia <cunshunxia@tencent.com> - 1.0-26
- only provide go-rpm-macros in subpkg.

* Tue Jul 16 2024 cunshunxia <cunshunxia@tencent.com> - 1.0-25
- requires and provides go-rpm-macros instead of go-srpm-macros.

* Tue Jul 09 2024 cunshunxia <cunshunxia@tencent.com> - 1.0-24
- add %%gomkdir for golang packaging.

* Thu Jun 6 2024 Shuo Wang <abushwang@tencent.com> - 1.0-23
- %pyproject_save_files: add support for nested directories and License-Files

* Mon May 27 2024 cunshunxia <cunshunxia@tencent.com> - 1.0-22
- add %%writevars for golang packaging.

* Wed May 22 2024 cunshunxia <cunshunxia@tencent.com> - 1.0-21
- add forge.lua macros.forge to support go rpm packaging.

* Wed May 08 2024 cunshunxia <cunshunxia@tencent.com> - 1.0-20
- add mono_arches for mono pkgs building

* Tue Mar 26 2024 cunshunxia <cunshunxia@tencent.com> - 1.0-19
- fix changelog error.

* Thu Mar 21 2024 cunshunxia <cunshunxia@tencent.com> - 1.0-18
- add macros.nodejs-srpm for nodejs building.

* Fri Mar 15 2024 Wenlong Zhang <zhangwenlong@loongson.cn> - 1.0-17
- add loongarch64 support for opencloudos-rpm-config

* Mon Sep 25 2023 cunshunxia <cunshunxia@tencent.com> - 1.0-16
- remove unused warnings.

* Thu Sep 14 2023 Shuo Wang <abushwang@tencent.com> - 1.0-15
- update __default_python3_version

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0-14
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0-13
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0-12
- Rebuilt for OpenCloudOS Stream 23

* Fri Mar 31 2023 rockerzhu <rockerzhu@tencent.com> - 1.0-11
- Fix not descending chronological order in changelog.

* Thu Mar 23 2023 Yi Lin <nilusyi@tencent.com> - 1.0-10
- remove rust-related macros, which are provided from rust-packaging.

* Thu Mar 23 2023 Shuo Wang <abushwang@tencent.com> - 1.0-9
- add go test macro

* Fri Mar 10 2023 cunshunxia <cunshunxia@tencent.com> - 1.0-8
- add %java_arches

* Thu Feb 23 2023 Xun Zhong <victorzhong@tencent.com> - 1.0-7
- eliminate file listed twice warning

* Thu Jan 12 2023 cunshunxia <cunshunxia@tencent.com> - 1.0-6
- make symlink requires soname-provide library.

* Thu Dec 29 2022 Shuo Wang <abushwang@tencent.com> - 1.0-5
- add py3_install_wheel macro

* Fri Dec 16 2022 abushwang <abushwang@tencent.com> - 1.0-4
- golang macros is supported to requires main

* Fri Dec 16 2022 abushwang <abushwang@tencent.com> - 1.0-3
- add macros for golang

* Wed Nov 30 2022 rockerzhu <rockerzhu@tencent.com> - 1.0-2
- add macros for shell completions

* Tue Aug 9 2022 cunshunxia <cunshunxia@tencent.com> - 1.0-1
- initial build
